<?xml version='1.0' encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		version="1.0"
                xmlns:xt="http://www.jclark.com/xt"
                extension-element-prefixes="xt">

<xsl:template match="/">
<ana><xsl:apply-templates select="//body"/></ana>
</xsl:template>

<xsl:template match="*[@ana]">
 <xsl:call-template name="ana-to-elements">
  <xsl:with-param name="anas" select="@ana"/>
 </xsl:call-template>
</xsl:template>

<xsl:template name="ana-to-elements">
 <xsl:param name="anas"/>
 <xsl:variable name="thisref"
select="substring-before(concat($anas,' '),' ')"/>
 <xsl:choose>
  <xsl:when test="not($thisref='')">
   <xsl:element name="{$thisref}">
    <xsl:call-template name="ana-to-elements">
     <xsl:with-param name="anas" select="substring-after($anas,' ')"/>
    </xsl:call-template>
   </xsl:element>
  </xsl:when>
  <xsl:otherwise>
   <xsl:apply-templates select="." mode="leaf"/>
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template match="date|docDate" mode="leaf">
  <xsl:element name="{name()}">
   <xsl:value-of select="@value"/>
  </xsl:element>
</xsl:template>

<xsl:template match="*[@value]">
  <xsl:element name="{name()}">
   <xsl:value-of select="@value"/>
  </xsl:element>
</xsl:template>

<xsl:template match="s[@n and contains(@ana,'age-')]" mode="leaf">
  <age><xsl:value-of select="@n"/></age>
</xsl:template>

<xsl:template match="*[@reg]" mode="leaf">
  <xsl:element name="{name()}">
   <xsl:value-of select="@reg"/>
  </xsl:element>
</xsl:template>

<xsl:template match="*[@corr]" mode="leaf">
  <xsl:element name="{name()}">
   <xsl:value-of select="@corr"/>
  </xsl:element>
</xsl:template>

</xsl:stylesheet>
