/*
 *  $Id: XmlDocumentParser.java,v 1.2 2001/11/28 20:36:20 fekete Exp $
 *  Copyright (C) 1998 Jean-Daniel Fekete and Ecole des Mines de Nantes
 *
 *  This file is part of Compus.
 *  Compus is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Library General Public License as published
 *  by the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import org.xml.sax.*;
import java.io.IOException;
import java.util.Locale;


public class XmlDocumentParser implements org.xml.sax.Parser {
  XmlDocument document;
  DocumentHandler handler;

  XmlDocumentParser() { }
  XmlDocumentParser(XmlDocument doc) {
    document = doc;
  }
  public void setDocument(XmlDocument doc) { document = doc; }
  public XmlDocument getDocument() { return document; }

  public void setLocale (Locale locale)
    throws SAXException { }
  public void setEntityResolver (EntityResolver resolver) { }
  public void setDTDHandler (DTDHandler handler) { }
  public void setDocumentHandler (DocumentHandler handler) {
    this.handler = handler;
  }
  public void setErrorHandler (ErrorHandler handler) { }
  public void parse (InputSource sourceIgnored)
    throws SAXException, IOException {
    //System.out.println("parse called");
    if (handler == null) return;
    char chars[] = document.getText().toCharArray();

    handler.startDocument();
    //System.out.println("startDocument called");
    int end = 0;
    for (int i = 0; i < document.eventCount(); i++) {
      XmlDocument.Event ev = document.getEvent(i);
      XmlDocument.Element e = ev.getElement();
      int start = end;
      end = ev.getPosition();
      if (start != end) {
	handler.characters(chars, start, end-start);
	//System.out.println((end-start)+"characters sent");
      }
      if (ev.type == XmlDocument.Event.START) {
	handler.startElement(e.name, e.atts);
	//System.out.println("start sent: "+e.name);
      } else {
	handler.endElement(e.name);
	//System.out.println("end sent: "+e.name);
      }
    }
    handler.endDocument();
  }
  public void parse (String systemId)
    throws SAXException, IOException {
  }
}
